/*
 * Copyright (C) 2020 Michael Krause
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
import 'package:array_object_adapter_example/model/comment_item.dart';
import 'package:array_object_adapter_example/model/post_item.dart';
import 'package:rxdart/rxdart.dart';

class HomePageViewModel {
  static const LOREM_IPSUM = "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, "
      "sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. "
      "At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus "
      "est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt "
      "ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. "
      "Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.";

  BehaviorSubject<List<dynamic>> _content$ = BehaviorSubject();

  Stream<List<dynamic>> get content => _content$;

  /// Loads the content of the page from the backend
  void downloadContent() {
    final result = <dynamic>[]
      ..add(PostItem(author: "Alice Cooper", text: LOREM_IPSUM))
      ..add(CommentItem(author: "User 1", text: LOREM_IPSUM.substring(0, 20)))
      ..add(CommentItem(author: "User 2", text: LOREM_IPSUM.substring(70, 100)))
      ..add(CommentItem(author: "User 3", text: LOREM_IPSUM.substring(0, 20)))
      ..add(CommentItem(author: "User 4", text: LOREM_IPSUM.substring(70, 100)))
      ..add(CommentItem(author: "Alice Cooper", text: LOREM_IPSUM.substring(1,15)))
      ..add(CommentItem(author: "User 1", text: LOREM_IPSUM.substring(0, 20)))
      ..add(CommentItem(author: "User 2", text: LOREM_IPSUM.substring(70, 100)))
      ..add(CommentItem(author: "User 3", text: LOREM_IPSUM.substring(0, 20)))
      ..add(CommentItem(author: "User 4", text: LOREM_IPSUM.substring(70, 100)))
      ..add(CommentItem(author: "User 5", text: LOREM_IPSUM.substring(0, 20)))
      ..add(CommentItem(author: "User 6", text: LOREM_IPSUM.substring(70, 100)))
      ..add(PostItem(author: "Tim Thompson", text: LOREM_IPSUM))
      ..add(CommentItem(author: "User 1", text: LOREM_IPSUM.substring(24, 80)))
      ..add(CommentItem(author: "User 2", text: LOREM_IPSUM.substring(18, 34)));
    return _content$.add(result);
  }
}
