/*
 * Copyright (C) 2020 Michael Krause
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
import 'package:array_object_adapter/array_object_adapter.dart';
import 'package:array_object_adapter_example/model/post_item.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

///
class PostItemPresenter extends Presenter {
  @override
  Widget createView(BuildContext context, Object item) {
    final post = item as PostItem;
    return Material(
      elevation: 8,
      type: MaterialType.card,
      child: Container(
        margin: EdgeInsets.all(8),
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            Container(
                width: double.infinity,
                child: Text(post.author, style: TextStyle(fontWeight: FontWeight.bold), textAlign: TextAlign.start)),
            SizedBox(height: 4),
            Text(post.text, style: TextStyle(fontWeight: FontWeight.normal)),
          ],
        ),
      ),
    );
  }
}
